/*
 * C compiler
 * ==========
 *
 * Copyright 1989, 1990, 1991 Christoph van Wuellen.
 * Credits to Matthew Brandt.
 * All commercial rights reserved.
 *
 * This compiler may be redistributed as long there is no
 * commercial interest. The compiler must not be redistributed
 * without its full sources. This notice must stay intact.
 *
 * History:
 *
 * 1989   starting an 68000 C compiler, starting with material
 *        originally by M. Brandt
 * 1990   68000 C compiler further bug fixes
 *        started i386 port (December)
 * 1991   i386 port finished (January)
 *        further corrections in the front end and in the 68000
 *        code generator.
 *        The next port will be a SPARC port
 */

#ifndef _GEN386_H
#define _GEN386_H

#include "genx86.h"

/* support routines */
#define	SUP_ASMUL	(CHAR *)".asmul"
#define	SUP_ASDIV	(CHAR *)".asdiv"
#define	SUP_FPADD	(CHAR *)".fpadd"
#define	SUP_FPCMP	(CHAR *)".fpcmp"
#define	SUP_FPDEC	(CHAR *)".fpdec"
#define	SUP_FPDIV	(CHAR *)".fpdiv"
#define	SUP_FPFADD	(CHAR *)".fpfadd"
#define	SUP_FPFDEC	(CHAR *)".fpfdec"
#define	SUP_FPFDIV	(CHAR *)".fpfdiv"
#define	SUP_FPFINC	(CHAR *)".fpfinc"
#define	SUP_FPFMULT	(CHAR *)".fpfmult"
#define	SUP_FPFNEG	(CHAR *)".fpfneg"
#define	SUP_FPFSUB	(CHAR *)".fpfsub"
#define	SUP_FPFTST	(CHAR *)".fpftst"
#define	SUP_FPGETSTK386	(CHAR *)".fpgetstk386"
#define	SUP_FPGETSTK387	(CHAR *)".fpgetstk387"
#define	SUP_FPINC	(CHAR *)".fpinc"
#define	SUP_FPLDI	(CHAR *)".fpldi"
#define	SUP_FPLDL	(CHAR *)".fpldl"
#define	SUP_FPLDS	(CHAR *)".fplds"
#define	SUP_FPLDU	(CHAR *)".fpdlu"
#define	SUP_FPLADD	(CHAR *)".fpladd"
#define	SUP_FPLDEC	(CHAR *)".fpldec"
#define	SUP_FPLDIV	(CHAR *)".fpldiv"
#define	SUP_FPLINC	(CHAR *)".fplinc"
#define	SUP_FPLMULT	(CHAR *)".fplmult"
#define	SUP_FPLNEG	(CHAR *)".fplneg"
#define	SUP_FPLSUB	(CHAR *)".fplsub"
#define	SUP_FPLTST	(CHAR *)".fpltst"
#define	SUP_FPMULT	(CHAR *)".fpmult"
#define	SUP_FPNEG	(CHAR *)".fpneg"
#define	SUP_FPPOP	(CHAR *)".fppop"
#define	SUP_FPPUTSTK386	(CHAR *)".fpputstk386"
#define	SUP_FPPUTSTK387	(CHAR *)".fpputstk387"
#define	SUP_FPSTI	(CHAR *)".fpsti"
#define	SUP_FPSTL	(CHAR *)".fpstl"
#define	SUP_FPSTPL	(CHAR *)".fpstpl"
#define	SUP_FPSTPS	(CHAR *)".fpstps"
#define	SUP_FPSTS	(CHAR *)".fpsts"
#define	SUP_FPSTU	(CHAR *)".fpstu"
#define	SUP_FPSUB	(CHAR *)".fpsub"
#define	SUP_FPTST	(CHAR *)".fptst"
#define	SUP__FLDI	(CHAR *)"._fldi"
#define	SUP__FLDU	(CHAR *)"._fldu"
#define	SUP__FSTI	(CHAR *)"._fsti"
#define	SUP__FSTU	(CHAR *)"._fstu"
#define	SUP_STACKCHECK	(CHAR *)".stackcheck"

#define	SUP_SFTOL	(CHAR *)".sftol"
#define	SUP_DFTOL	(CHAR *)".dftol"
#define	SUP_LFTOL	(CHAR *)".lftol"
#define	SUP_SFTOUL	(CHAR *)".sftoul"
#define	SUP_DFTOUL	(CHAR *)".dftoul"
#define	SUP_LFTOUL	(CHAR *)".lftoul"
#define	SUP_LTOSF	(CHAR *)".ltosf"
#define	SUP_ULTOSF	(CHAR *)".ultosf"
#define	SUP_DFTOSF	(CHAR *)".dftosf"
#define	SUP_LFTOSF	(CHAR *)".uftosf"
#define	SUP_LTODF	(CHAR *)".ltodf"
#define	SUP_ULTODF	(CHAR *)".ultodf"
#define	SUP_SFTODF	(CHAR *)".sftodf"
#define	SUP_LFTODF	(CHAR *)".lftodf"
#define	SUP_LTOLF	(CHAR *)".ltolf"
#define	SUP_ULTOLF	(CHAR *)".ultolf"
#define	SUP_SFTOLF	(CHAR *)".sftolf"
#define	SUP_DFTOLF	(CHAR *)".dftolf"
#endif /* _GEN386_H */
